package com.jpsoft.picc.modules.base.service.impl;

import java.util.List;
import java.util.Map;
import java.util.UUID;
import javax.annotation.Resource;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import com.jpsoft.picc.modules.base.dao.CompanyDAO;
import com.jpsoft.picc.modules.base.entity.Company;
import com.jpsoft.picc.modules.base.service.CompanyService;
import com.github.pagehelper.Page;
import com.jpsoft.picc.modules.common.dto.Sort;
import com.github.pagehelper.PageHelper;

@Transactional
@Component(value="companyService")
public class CompanyServiceImpl implements CompanyService {
	@Resource(name="companyDAO")
	private CompanyDAO companyDAO;

	@Override
	public Company get(String id) {
		// TODO Auto-generated method stub
		return companyDAO.get(id);
	}

	@Override
	public int insert(Company model) {
		// TODO Auto-generated method stub
		//model.setId(UUID.randomUUID().toString());
		
		return companyDAO.insert(model);
	}

	@Override
	public int update(Company model) {
		// TODO Auto-generated method stub
		return companyDAO.update(model);		
	}

	@Override
	public int delete(String id) {
		// TODO Auto-generated method stub
		return companyDAO.delete(id);
	}

	@Override
	public boolean exist(String id) {
		// TODO Auto-generated method stub
		int count = companyDAO.exist(id);
		
		return count > 0 ? true : false;
	}

	@Override
	public List<Company> list() {
		// TODO Auto-generated method stub
		return companyDAO.list();
	}

	@Override
	public List<Company> findByPromoter(String promoter){
		return companyDAO.findByPromoter(promoter);
	}

	@Override
	public List<Company> findByPromoterAndCreatTime(String promoter,String startTime,String endTime){
		return companyDAO.findByPromoterAndCreatTime(promoter,startTime,endTime);
	}

	@Override
	public Page<Company> pageSearch(Map<String, Object> searchParams, int pageNumber, int pageSize,List<Sort> sortList) {
        Page<Company> page = PageHelper.startPage(pageNumber,pageSize).doSelectPage(()->{
            companyDAO.search(searchParams,sortList);
        });

        return page;
	}

	@Override
	public Company findByCreateBy(String userId) {
		return companyDAO.findByCreateBy(userId);
	}
}