package com.jpsoft.picc.modules.common.utils;





import java.io.UnsupportedEncodingException;
import java.util.HashMap;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;

/**
 * @author 墨鱼_mo
 * @date 2020-2-11 10:22
 */
public class SignUtil {
    /**
     * 创建签名
     * @return
     */
    public static String createSign(HashMap<String,Object> paramMap, String key){

        SortedMap<String,Object> sortMap = new TreeMap<String,Object>(paramMap);

        String sign = "";

        for (Map.Entry<String, Object> entry : sortMap.entrySet()) {
            if (entry.getValue() == null || "".equals(entry.getValue().toString())){
                sign += entry.getKey() + "=|";
            }else {
                sign += entry.getKey() + "=" + entry.getValue() + "|";
            }
        }

        sign += key;

        String md5_sign = "";

        try {
            md5_sign = MD5Util.getMD5(sign.getBytes("utf-8"));
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }


        return md5_sign;

    }

    /**
     * 验证签名
     * @return
     */
    public static boolean validateSign(HashMap<String,Object> paramMap,String key,String sign){

        SortedMap<String,Object> sortMap = new TreeMap<String,Object>(paramMap);

        String validate_sign = "";

        for (Map.Entry<String, Object> entry : sortMap.entrySet()) {
            if (entry.getValue() == null || "".equals(entry.getValue().toString())){
                validate_sign += entry.getKey() + "=|";
            }
            else {
                validate_sign += entry.getKey() + "=" + entry.getValue() + "|";
            }
        }

        validate_sign += key;

        String md5_sign = "";

        try {
            md5_sign = MD5Util.getMD5(validate_sign.getBytes("utf-8"));
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        System.out.println(">>>>>>>>>>sign>>>>" + sign);
        System.out.println(">>>>>>>>>>>md5_sign>>>>" + md5_sign);

        if(md5_sign.equals(sign)){
            return true;
        }else{
            return false;
        }
    }

    public static void main(String[] args){
        HashMap<String,Object> signMap = new HashMap<String,Object>();

        signMap.put("orderNo","20200309163902105");
        signMap.put("payType","1");
        signMap.put("code","008");
        signMap.put("payTime","1583743142");
        signMap.put("userMoney","1000");

        String md5_sign = "";

        SortedMap<String,Object> sortMap = new TreeMap<String,Object>(signMap);

        String validate_sign = "";

        for (Map.Entry<String, Object> entry : sortMap.entrySet()) {
            validate_sign += entry.getKey() + "=" + entry.getValue() + "|";
        }

        validate_sign += "1234567890";

        try {
            md5_sign = MD5Util.getMD5(validate_sign.getBytes("utf-8"));
        } catch (UnsupportedEncodingException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        System.out.println(md5_sign);
    }

}
